tree: ba4963acfec2c12b7c8e34f30a6711e6e49cfe5b [path history] [tgz]
  1. README.md
  2. doc/
  3. go.mod
  4. go.sum
  5. integration/
  6. internal/
  7. main.go
  8. release/
  9. test/
gopls/README.md

gopls, the Go language server

PkgGoDev

gopls (pronounced “Go please”) is the official Go language server developed by the Go team. It provides IDE features to any LSP-compatible editor.

You should not need to interact with gopls directly--it will be automatically integrated into your editor. The specific features and settings vary slightly by editor, so we recommend that you proceed to the documentation for your editor below.

Editors

To get started with gopls, install an LSP plugin in your editor of choice.

If you use gopls with an editor that is not on this list, please let us know by filing an issue or modifying this documentation.

Installation

For the most part, you should not need to install or update gopls. Your editor should handle that step for you.

If you do want to get the latest stable version of gopls, change to any directory that is both outside of your GOPATH and outside of a module (a temp directory is fine), and run:

GO111MODULE=on go get golang.org/x/tools/gopls@latest

NOTE: Do not use the -u flag, as it will update your dependencies to incompatible versions.

Learn more in the advanced installation instructions.

Setting up your workspace

gopls supports both Go module and GOPATH modes, but if you are working with multiple modules or uncommon project layouts, you will need to specifically configure your workspace. See the Workspace document for information on supported workspace layouts.

Configuration

You can configure gopls to change your editor experience or view additional debugging information. Configuration options will be made available by your editor, so see your editor's instructions for specific details. A full list of gopls settings can be found in the Settings documentation.

Environment variables

gopls inherits your editor's environment, so be aware of any environment variables you configure. Some editors, such as VS Code, allow users to selectively override the values of some environment variables.

Troubleshooting

If you are having issues with gopls, please follow the steps described in the troubleshooting guide.

Supported Go versions and build systems

gopls follows the Go Release Policy, meaning that it officially supports the last 2 major Go releases. Per issue #39146, we attempt to maintain best-effort support for the last 4 major Go releases, but this support extends only to not breaking the build and avoiding easily fixable regressions.

Our extended support is enforced via continuous integration with older Go versions. This legacy Go CI may not block releases: test failures may be skipped rather than fixed. Furthermore, if a regression in an older Go version causes irreconcilable CI failures, we may drop support for that Go version in CI if it is 3 or 4 Go versions old.

gopls currently only supports the go command, so if you are using a different build system, gopls will not work well. Bazel support is currently blocked on bazelbuild/rules_go#512.

Additional information